<?php
/**
 * ***** Functions to improve xili-language *****
 * ** selection for twentyten-xili child of twentyten **
 */

/**
 * ***** BreadCrump ******
 * @since 20101111
 *
 * can be adapted with two end params
 */
function xiliml_adjacent_join_filter($join, $in_same_cat, $excluded_categories) {
	global $post, $wpdb;
	$curlang = xiliml_get_lang_object_of_post( $post->ID );
	// in join p is $wpdb->posts AS p in get_adjacent_post of lin_template.php
	if ($curlang) { // only when language is defined !
		$join .= " LEFT JOIN $wpdb->term_relationships as xtr ON (p.ID = xtr.object_id) LEFT JOIN $wpdb->term_taxonomy as xtt ON (xtr.term_taxonomy_id = xtt.term_taxonomy_id) ";
	}	
return $join;
}

function xiliml_adjacent_where_filter($where, $in_same_cat, $excluded_categories) {
	global $post;
	$curlang = xiliml_get_lang_object_of_post( $post->ID );
	if ( $curlang ) {
		$wherereqtag = $curlang->term_id; 
		$where .= " AND xtt.taxonomy = '".TAXONAME."' ";
		$where .= " AND xtt.term_id = $wherereqtag "; 
	}
	return $where;
}

if ( class_exists('xili_language') ) {
	
	add_filter('get_next_post_join','xiliml_adjacent_join_filter',10,3);
	add_filter('get_previous_post_join','xiliml_adjacent_join_filter',10,3);
	
	add_filter('get_next_post_where','xiliml_adjacent_where_filter',10,3);
	add_filter('get_previous_post_where','xiliml_adjacent_where_filter',10,3);
	
}


/**
 * add search other languages in form - see functions.php when fired
 *
 */
function my_langs_in_search_form ( $the_form ) {
	
	$form = '<form role="search" method="get" id="searchform" action="' . home_url( '/' ) . '" >
	<div><label class="screen-reader-text" for="s">' . __('Search for:') . '</label>
	<input type="text" value="' . get_search_query() . '" name="s" id="s" />
	<input type="submit" id="searchsubmit" value="'. esc_attr__('Search') .'" />
	</div>';
	$form .= xiliml_langinsearchform ($before='', $after='', false);
	$form .= '</form>';
	return $form ;
}

/*special flags in list*/
function xiliml_infunc_the_other_posts($post_ID, $before = "Read This post in", $separator = ", ", $type = "display") {
			$outputarr = array();
			$listlanguages = get_terms(TAXONAME, array('hide_empty' => false));
			$post_lang = get_cur_language($post_ID); // to be used in multilingual loop since 1.1
			//$post_lang = $langpost['lang']; //print_r($langpost);
			foreach ($listlanguages as $language) {
				$otherpost = get_post_meta($post_ID, 'lang-'.$language->slug, true);
				
				if ($type == "display") {
					if ('' != $otherpost && $language->slug != $post_lang ) {
						$outputarr[] = "<a href='".get_permalink($otherpost)."' >".__($language->description,the_theme_domain()) ." <img src='".get_bloginfo('stylesheet_directory')."/images/flags/".$language->slug.".png' alt='' /></a>";
					}
				} elseif ($type == "array") { // here don't exclude cur lang
					if ('' != $otherpost)
						$outputarr[$language->slug] = $otherpost;
				}
			}
			if ($type == "display") {
				if (!empty($outputarr))
					$output =  (($before !="") ? __($before,the_theme_domain())." " : "" ).implode ($separator, $outputarr);
				if ('' != $output) { echo $output;}	
			} elseif ($type == "array") {
				if (!empty($outputarr)) {
					$outputarr[$post_ID] = $post_lang; 
					// add a key with curid to give his lang (empty if undefined)
					return $outputarr;
				} else {
					return false;	
				}
			}	
						
}
add_filter('xiliml_the_other_posts','xiliml_infunc_the_other_posts',10,4); // 1.1 090917

function my_xiliml_cat_language ($content, $category = null) {
		//if (has_filter('xiliml_cat_language')) return apply_filters('xiliml_cat_language',$content, $category,$this->curlang);
		/* default */ 
	            /*set by locale of wpsite*/
	      /*these rules can be changed by using */
	    if (!is_admin()) : /*to detect admin UI*/
	      	$new_cat_name =  __($category->name,the_theme_domain()); /*visible ??? in dashboard ???*/
	      	//if ($new_cat_name != $content) : 
	      		//$new_cat_name .= " (". $content .") ";
	      	//endif;
	      		 		/* due to default if no translation*/
	    else :
	    	$new_cat_name =  $content;
	    endif; 
	    return $new_cat_name;
	 } 
// add_filter('xiliml_cat_language','my_xiliml_cat_language',2,3);

/**
 * special flags in list of available languages
 * @updated 1.8.1 - 20101026
 * @updated 1.8.9.1 - 20101216 $hidden
 * @updated for 2.1 - 20110521 for new options
 */
function xiliml_infunc_language_list($before = '<li>', $after ='</li>', $theoption, $echo = true, $hidden = false ) {
	global $wp_query, $post;      
	$before_class = false ;
	if ( substr($before,-2) == '.>' ) {
		$before_class = true ;
		$before = str_replace('.>','>',$before);
	}
	$listlanguages = xili_get_listlanguages();
	if ($theoption == 'top') {
			
		$a ='';
		$currenturl = get_bloginfo('siteurl').'/?';
		foreach ($listlanguages as $language) { 
			$display = ( $hidden && ( xl_lang_features ( $language->slug, 'hidden' ) == 'hidden' ) ) ? false : true ;
			if ( $display ) {
				$a .= $before ."<a href='".$currenturl."lang"."=".$language->slug."' title='".__('Latest posts selected',the_theme_domain())." ".__('in '.$language->description,the_theme_domain())."'>"." <img src='".get_bloginfo('template_directory')."/images/flags/".$language->slug.".png' alt='' /></a>".$after;
			}
		}
	} elseif ($theoption == 'typeonenew') { // 2.1.0
			/* the rules : don't display the current lang if set and add link of category if is_category()*/
			if (is_category()) {  
				$catcur = xiliml_get_category_link();
				$permalink = get_option('permalink_structure'); /* 1.6.0 */
				$sep = ('' == $permalink) ? "&amp;" : "?" ;
				$currenturl = $catcur.$sep;
			} else {
		 		$currenturl = get_bloginfo('url').'/?';
			}
			foreach ($listlanguages as $language) {  
				$display = ( $hidden && ( xl_lang_features ( $language->slug, 'hidden' ) == 'hidden' ) ) ? false : true ;
				if ($language->slug != the_curlang()   && $display ) {
					$beforee = ( $before_class && $before == '<li>' ) ? '<li class="lang-'.$language->slug.'" >': $before;
					$class = " class='lang-".$language->slug."'";
					
					if ( ( is_single() || is_page() ) && !is_front_page() ) {	
						$thelink = xl_get_linked_post_in ( $post->ID, $language->slug, 'permalinknav' ) ; // other or home
												
						$title = sprintf (__('Current post in %s', the_theme_domain()), __($language->description, the_theme_domain()) ) ;
					} else {
						$thelink = $currenturl . QUETAG . "=" . $language->slug ;
						$title = sprintf (__('Posts selected in %s', the_theme_domain()), __($language->description, the_theme_domain()) ) ;
					}
			
					$a .= $beforee ."<a{$class} href='".$thelink."' title='".$title."' >". __($language->description, the_theme_domain()) ."</a>".$after;
				}
			}	
		
	} elseif ($theoption == 'siderss') {
		if (is_category()) {  
			$catcururl = xiliml_get_category_link();
			$sep = ('' != $permalink || is_multisite() ) ?  "?" : "&amp;" ;
			$currenturl = $catcururl.$sep;
			
			$cat_ID = $wp_query->query_vars['cat'];
			$currentrss = get_bloginfo('siteurl').'?feed=rss2&amp;cat='.$cat_ID; 
		} else { 
		 	$currenturl = get_bloginfo('siteurl').'/?';
		 	$currentrss = get_bloginfo('siteurl').'/?feed=rss2';
		}
				
		foreach ($listlanguages as $language) {
			$display = ( $hidden && ( xl_lang_features ( $language->slug, 'hidden' ) == 'hidden' ) ) ? false : true ;
			if ( $display ) {
				if ($before=='<li>') {
					if (the_curlang() == $language->slug) { 
						$beforee = ($before_class) ? '<li class="lang-'.$language->slug.' current-cat" >' : '<li class="current-cat" >';
					} else {
						$beforee = ($before_class) ? '<li class="lang-'.$language->slug.'" >': '<li>';
					}
				}
				 
				$a .= $beforee ."<a href='".$currenturl.QUETAG."=".$language->slug."' title='".__('Posts selected',the_theme_domain())." ".__('in '.$language->description,the_theme_domain())."'>"." <img src='".get_bloginfo('stylesheet_directory')."/images/flags/".$language->slug.".png' alt='' /> ". __($language->description,the_theme_domain()) ."</a> <a href='".$currentrss.'&amp;'.QUETAG."=".$language->slug."'><img src='".get_bloginfo('stylesheet_directory')."/images/rss.png' alt='rss'/></a>".$after;
			}
		
		}
		
		if (is_category()) {
			$currenturl = xiliml_get_category_link();
			$a .= $before."<a href='".$currenturl."' title='".__('Posts of current category in all languages',the_theme_domain())."' >"." <img src='".get_bloginfo('stylesheet_directory')."/images/flags/www.png' alt='' /> ".__('in all languages',the_theme_domain())."</a> <a href='".$currentrss."'><img src='".get_bloginfo('stylesheet_directory')."/images/rss.png' alt='rss'/></a>".$after;
			}
			
	
	} elseif ($theoption == 'navmenu')  {	/* current list in nav menu 1.6.0 */
			
				foreach ($listlanguages as $language) {
					$display = ( $hidden && ( xl_lang_features ( $language->slug, 'hidden' ) == 'hidden' ) ) ? false : true ;
					if ( $display ) {
						if ($language->slug != the_curlang() ) {
							$class = " class='menu-item menu-item-type-custom lang-".$language->slug."'";
						} else {
							$class = " class='menu-item menu-item-type-custom lang-".$language->slug." current-lang current-menu-item'";
						}
						$beforee = (substr($before,-1) == '>') ? str_replace('>',' '.$class.' >' , $before ) : $before ;
						$a .= $beforee ."<a href='".get_bloginfo('url')."/?".QUETAG."=".$language->slug."' title='".__('Posts selected',the_theme_domain())." ".__('in '.$language->description,the_theme_domain())."'>". __($language->description,the_theme_domain()) ."</a>".$after;
					}
				}
						
	} elseif ($theoption == 'navmenu-1')  {	// 2.1.0
			if (is_category()) {  
						$catcur = xiliml_get_category_link();
						$permalink = get_option('permalink_structure'); /* 1.6.0 */
						$sep = ('' == $permalink) ? "&amp;" : "?" ;
						$currenturl = $catcur.$sep;
					} else {
		 				$currenturl = get_bloginfo('url').'/?';
					}
			
			foreach ($listlanguages as $language) { 
				$display = ( $hidden && ( xl_lang_features ( $language->slug, 'hidden' ) == 'hidden' ) ) ? false : true ;
				if ( $display ) { 
					
					if ($language->slug != the_curlang() ) {
						$class = " class='menu-item menu-item-type-custom lang-".$language->slug."'";
					} else {
						$class = " class='menu-item menu-item-type-custom lang-".$language->slug." current-lang current-menu-item'";
					}
					
					if ( ( is_single() || is_page() ) && !is_front_page() ) {	
						$thelink = xl_get_linked_post_in ( $post->ID, $language->slug, 'permalinknav' ) ; // other or home
						$title = sprintf (__('Current post in %s', the_theme_domain()), __($language->description, the_theme_domain() ) ) ;
					} else {
						$thelink = $currenturl . QUETAG . "=" . $language->slug ;
						$title = sprintf (__('Posts selected in %s', the_theme_domain()), __($language->description, the_theme_domain() ) ) ;
					}
					
					$beforee = (substr($before,-1) == '>') ? str_replace('>',' '.$class.' >' , $before ) : $before ;
					$a .= $beforee ."<a href='".$thelink."' title='".$title."'>". __($language->description, the_theme_domain() ) ."</a>".$after;
				}
			}
			
	
	} else { /* the current list in sidebar */
		
		if (is_category()) {  
			$catcur = xiliml_get_category_link();
			$currenturl = $catcur.'&amp;'; 
		} else {
		 	$currenturl = get_bloginfo('siteurl').'/?';
		}
		
		foreach ($listlanguages as $language) {
			$display = ( $hidden && ( xl_lang_features ( $language->slug, 'hidden' ) == 'hidden' ) ) ? false : true ;
			if ( $display ) {
				if ($before=='<li>') {
					if (the_curlang() == $language->slug) { 
						$beforee = '<li class="current-cat" >';
					} else {
						$beforee ='<li>';
					}
				}
				
				$a .= $beforee ."<a href='".$currenturl.QUETAG."=".$language->slug."' title='".__('Posts selected',the_theme_domain())." ".__('in '.$language->description,the_theme_domain())."'>"." <img src='".get_bloginfo('stylesheet_directory')."/images/flags/".$language->slug.".png' alt='' /> ".__($language->description,the_theme_domain()) ."</a>".$after;
			}
		
		}
		
		if (is_category()) {
			$currenturl = xiliml_get_category_link();
			$a .= $before."<a href='".$currenturl."' title='".__('Posts of current category in all languages',the_theme_domain())."' >"." <img src='".get_bloginfo('stylesheet_directory')."/images/flags/www.png' alt='' /> ".__('in all languages',the_theme_domain())."</a>".$after;
			}
		
	}
	if ($echo) 
				echo $a;
			else
				return $a;		
}

add_action('xili_language_list','xiliml_infunc_language_list',10,5); // 1.8.9.1

/** 
 * this part to populate popup menu in widget named language list 
 */
function my_xili_language_list_options ($option = null) {
	global $xili_language;
		$xili_language->langs_list_options = array( array('', 'default'), array('top','Type top'), array('navmenu','Menu'), array('navmenu-1','Menu #1'), array('typeonenew', 'Type for single'), array('siderss', 'Type RSS')); 
	
	}
add_action('xili_language_list_options','my_xili_language_list_options',10,1);


?>
